<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper
PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"http://mybatis.org/dtd/mybatis-3-mapper.dtd">
<mapper namespace="com.dcs.hnyz.mapper.ScreenSettingsMapper">
    
    <resultMap type="ScreenSettings" id="ScreenSettingsResult">
        <result property="id"    column="id"    />
        <result property="screenName"    column="screen_name"    />
        <result property="code"    column="code"    />
        <result property="pageId"    column="page_id"    />
        <result property="status"    column="status"    />
        <result property="createBy"    column="create_by"    />
        <result property="createTime"    column="create_time"    />
        <result property="updateBy"    column="update_by"    />
        <result property="updateTime"    column="update_time"    />
        <result property="remark"    column="remark"    />
    </resultMap>

    <sql id="selectScreenSettingsVo">
        select id, screen_name, code, page_id, status, create_by, create_time, update_by, update_time, remark from screen_settings
    </sql>

    <select id="selectScreenSettingsList" parameterType="ScreenSettings" resultMap="ScreenSettingsResult">
        <include refid="selectScreenSettingsVo"/>
        <where>  
            <if test="screenName != null  and screenName != ''"> and screen_name like concat('%', #{screenName}, '%')</if>
            <if test="code != null  and code != ''"> and code = #{code}</if>
            <if test="status != null  and status != ''"> and status = #{status}</if>
        </where>
    </select>
    
    <select id="selectScreenSettingsById" parameterType="Long" resultMap="ScreenSettingsResult">
        <include refid="selectScreenSettingsVo"/>
        where id = #{id}
    </select>
    <select id="selectScreenSettingsFormList" resultType="com.dcs.hnyz.domain.vo.ScreenSettingsFormVO">
        SELECT
            a.*,
            b.page_name
        FROM
            screen_settings AS a
                INNER JOIN
            template_page AS b
            ON
                a.page_id = b.page_id
        <where>
            <if test="screenName != null  and screenName != ''"> and screen_name like concat('%', #{screenName}, '%')</if>
            <if test="code != null  and code != ''"> and code = #{code}</if>
            <if test="status != null  and status != ''"> and a.status = #{status}</if>
        </where>
    </select>

    <insert id="insertScreenSettings" parameterType="ScreenSettings" useGeneratedKeys="true" keyProperty="id">
        insert into screen_settings
        <trim prefix="(" suffix=")" suffixOverrides=",">
            <if test="screenName != null and screenName != ''">screen_name,</if>
            <if test="code != null and code != ''">code,</if>
            <if test="pageId != null">page_id,</if>
            <if test="status != null">status,</if>
            <if test="createBy != null">create_by,</if>
            <if test="createTime != null">create_time,</if>
            <if test="updateBy != null">update_by,</if>
            <if test="updateTime != null">update_time,</if>
            <if test="remark != null">remark,</if>
         </trim>
        <trim prefix="values (" suffix=")" suffixOverrides=",">
            <if test="screenName != null and screenName != ''">#{screenName},</if>
            <if test="code != null and code != ''">#{code},</if>
            <if test="pageId != null">#{pageId},</if>
            <if test="status != null">#{status},</if>
            <if test="createBy != null">#{createBy},</if>
            <if test="createTime != null">#{createTime},</if>
            <if test="updateBy != null">#{updateBy},</if>
            <if test="updateTime != null">#{updateTime},</if>
            <if test="remark != null">#{remark},</if>
         </trim>
    </insert>

    <update id="updateScreenSettings" parameterType="ScreenSettings">
        update screen_settings
        <trim prefix="SET" suffixOverrides=",">
            <if test="screenName != null and screenName != ''">screen_name = #{screenName},</if>
            <if test="code != null and code != ''">code = #{code},</if>
            <if test="pageId != null">page_id = #{pageId},</if>
            <if test="status != null">status = #{status},</if>
            <if test="createBy != null">create_by = #{createBy},</if>
            <if test="createTime != null">create_time = #{createTime},</if>
            <if test="updateBy != null">update_by = #{updateBy},</if>
            <if test="updateTime != null">update_time = #{updateTime},</if>
            <if test="remark != null">remark = #{remark},</if>
        </trim>
        where id = #{id}
    </update>

    <delete id="deleteScreenSettingsById" parameterType="Long">
        delete from screen_settings where id = #{id}
    </delete>

    <delete id="deleteScreenSettingsByIds" parameterType="String">
        delete from screen_settings where id in 
        <foreach item="id" collection="array" open="(" separator="," close=")">
            #{id}
        </foreach>
    </delete>
</mapper>